package gs.test.v0

import munit.*

class GroupImplementationTests extends FunSuite:
  import GroupImplementationTests.* 

  test("should support a group with a simple, pure, test") {
    val g1 = new G1
    val group = g1.toGroupDefinition()
    assertEquals(group.name, TestGroupDefinition.Name("G1"))
    assertEquals(group.documentation, None)
    assertEquals(group.testTags, List.empty)
    assertEquals(group.testMarkers, List.empty)
    assertEquals(group.beforeGroup, None)
    assertEquals(group.afterGroup, None)
    assertEquals(group.beforeEachTest, None)
    assertEquals(group.afterEachTest, None)
    assertEquals(group.tests.size, 1)

    group.tests match
      case t :: Nil =>
        assertEquals(t.name, TestDefinition.Name("simple"))
        assertEquals(t.permanentId, Ids.T1)
        assertEquals(t.documentation, None)
        assertEquals(t.tags, List.empty)
        assertEquals(t.markers, List.empty)
        assertEquals(t.iterations, TestDefinition.Iterations.One)
      case _ => fail("Unexpected number of defined tests.")
  }

object GroupImplementationTests:

  object Ids:

    val T1: PermanentId = PermanentId("t1")

  end Ids

  class G1 extends TestGroup.IO:
    override def name: String = "G1"
    test(Ids.T1, "simple").pure { Right(()) }
  end G1

end GroupImplementationTests
